module PROGRAM_COUNTER #(
  parameter BITS = 8
)(
  input                 i_clk,
  input                 i_rst,
  input                 i_co,
  input                 i_ce,
  input                 i_j,
  inout      [BITS-1:0] io_bus,
  input                 i_bus_active,
  output reg [BITS-1:0] o_pc
);

always @(posedge i_clk || i_rst) begin
  if (i_rst)
    o_pc <= (BITS)'d0;
  else if (i_j)
    o_pc <= (i_bus_active) ? io_bus : {BITS{1'b0}};
  else if (i_ce)
    o_pc <= o_pc + (BITS)'d1;
end

assign io_bus = i_co ? o_pc : {BITS{1'bz}};

endmodule
