; Primes.asm
; Find prime numbers
; maurits@dijkens.com
	MOV A,0
	MOV iters,A			; number of runs runs
init:
	MOV A,1
	MOV primes,A		; number of found primes in list
	MOV pindex,A		; index in list of current pdiv
	MOV paddr,A			; address of current pdiv
	MOV pdiv,A			; current prime from list to divide candidate
	MOV D,A					; 1: we start candidates at 3 (ADD A,2)
	MOV A,2
	MOV list0,A			; first prime (2) at last address after all other vars
main:
	OUT A						; first prime is 2 we don't calc
cand_nxt:					; start for each cand 3 5 7 ... CF
	MOV A,D
	ADD A,2					; cand 3 5 7 ... CF
	JC end					; cand >255: end
	MOV D,A
	MOV A,0					; set pindex=0 to go with pdiv through list
	MOV pindex,A		;
pdiv_nxt:
	MOV A,pindex		;
	INC A						; next pindex
	MOV pindex,A		;
	MOV A,primes
	CMP A,pindex		; primes-pindex = 0?
	JZ  found				; pindex=primes tried whole list prime found
									; pindex<primes continue
pdiv_cont:
	LEA A,list0			; get address of list0
	ADD A,pindex		; set address to point to current pdiv
	MOV paddr,A			; store address of current pdiv
	MOV B,[paddr]		; load current pdiv
	MOV pdiv,B			; store current pdiv
	MOV A,D					; load candidate in A
subtract:
	SUB A,B					; subtract pdiv
	JZ cand_nxt			; cand can be divided by pdiv so no prime
	JC subtract
	JMP pdiv_nxt		; cand cannot be divided by pdiv so next pdiv in list
found:
	LEA A,list0			; get address of list0						; 59
	ADD A,primes		; point to new prime list address			; 1	5A
	MOV pindex,A		; temp pindex for new address					; pindex=60
	MOV A,primes		; load no of found primes							; primes=1
	INC A						; increment														; primes=2
	MOV primes,A		; store new no of primes
	OUT D						; load new found prime to output
	MOV [pindex],D	; store new prime in list
	JMP cand_nxt		; find next candidate
end:
	MOV A,iters
	INC A
	MOV iters,A
	CMP A,IN
	JNC init
	END
	primes:1				; number of found primes in list
	pindex:1				; index in list of current pdiv
	paddr:1					; address of current pdiv
	pdiv:1					; current prime from list to divide candidate (D)
	iters:0					; number of times program has run
	list0:2					; LAST ADDRESS: first prime (2)
